<?php
namespace CreativeButtons\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class CBTNSCreativeButtons extends Widget_Base {

	public function get_name() {
		return esc_html__( 'NameCreativeButtons', 'bwd-creative-buttons' );
	}

	public function get_title() {
		return esc_html__( 'BWD Creative Buttons', 'elementor' );
	}

	public function get_icon() {
		return 'cbtns-buttons-icon eicon-dual-button';
	}

	public function get_categories() {
		return [ 'bwd-creative-buttons-category' ];
	}

	public function get_script_depends() {
		return [ 'bwd-creative-buttons-category' ];
	}

	protected function register_controls() {
		$this->start_controls_section(
			'cbtns_buttons_content_section',
			[
				'label' => esc_html__( 'Buttons Content', 'bwd-creative-buttons' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'cbtns_style_selection',
			[
				'label' => esc_html__( 'Button Styles', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'one',
				'options' => [
					'one' => esc_html__( 'Style 1', 'bwd-creative-buttons' ),
					'two' => esc_html__( 'Style 2', 'bwd-creative-buttons' ),
					'three' => esc_html__( 'Style 3', 'bwd-creative-buttons' ),
					'four' => esc_html__( 'Style 4', 'bwd-creative-buttons' ),
					'five' => esc_html__( 'Style 5', 'bwd-creative-buttons' ),
					'six' => esc_html__( 'Style 6', 'bwd-creative-buttons' ),
					'seven' => esc_html__( 'Style 7', 'bwd-creative-buttons' ),
					'eight' => esc_html__( 'Style 8', 'bwd-creative-buttons' ),
					'nine' => esc_html__( 'Style 9', 'bwd-creative-buttons' ),
					'ten' => esc_html__( 'Style 10', 'bwd-creative-buttons' ),
					'eleven' => esc_html__( 'Style 11', 'bwd-creative-buttons' ),
					'twelve' => esc_html__( 'Style 12', 'bwd-creative-buttons' ),
					'thirteen' => esc_html__( 'Style 13', 'bwd-creative-buttons' ),
					'fourteen' => esc_html__( 'Style 14', 'bwd-creative-buttons' ),
					'fifteen' => esc_html__( 'Style 15', 'bwd-creative-buttons' ),
					'sixteen' => esc_html__( 'Style 16', 'bwd-creative-buttons' ),
					'seventeen' => esc_html__( 'Style 17', 'bwd-creative-buttons' ),
					'eighteen' => esc_html__( 'Style 18', 'bwd-creative-buttons' ),
					'nineteen' => esc_html__( 'Style 19', 'bwd-creative-buttons' ),
					'twenty' => esc_html__( 'Style 20', 'bwd-creative-buttons' ),
					'twentyone' => esc_html__( 'Style 21', 'bwd-creative-buttons' ),
					'twentytwo' => esc_html__( 'Style 22', 'bwd-creative-buttons' ),
					'twentythree' => esc_html__( 'Style 23', 'bwd-creative-buttons' ),
					'twentyfour' => esc_html__( 'Style 24', 'bwd-creative-buttons' ),
					'twentyfive' => esc_html__( 'Style 25', 'bwd-creative-buttons' ),
					'twentysix' => esc_html__( 'Style 26', 'bwd-creative-buttons' ),
					'twentyseven' => esc_html__( 'Style 27', 'bwd-creative-buttons' ),
					'twentyeight' => esc_html__( 'Style 28', 'bwd-creative-buttons' ),
					'twentynine' => esc_html__( 'Style 29', 'bwd-creative-buttons' ),
					'thirty' => esc_html__( 'Style 30', 'bwd-creative-buttons' ),
					'thirtyone' => esc_html__( 'Style 31', 'bwd-creative-buttons' ),
					'thirtytwo' => esc_html__( 'Style 32', 'bwd-creative-buttons' ),
					'thirtythree' => esc_html__( 'Style 33', 'bwd-creative-buttons' ),
					'thirtyfour' => esc_html__( 'Style 34', 'bwd-creative-buttons' ),
					'thirtyfive' => esc_html__( 'Style 35', 'bwd-creative-buttons' ),
					'thirtysix' => esc_html__( 'Style 36', 'bwd-creative-buttons' ),
					'thirtyseven' => esc_html__( 'Style 37', 'bwd-creative-buttons' ),
					'thirtyeight' => esc_html__( 'Style 38', 'bwd-creative-buttons' ),
					'thirtynine' => esc_html__( 'Style 39', 'bwd-creative-buttons' ),
					'fourty' => esc_html__( 'Style 40', 'bwd-creative-buttons' ),
					'fourtyone' => esc_html__( 'Style 41', 'bwd-creative-buttons' ),
					'fourtytwo' => esc_html__( 'Style 42', 'bwd-creative-buttons' ),
					'fourtythree' => esc_html__( 'Style 43', 'bwd-creative-buttons' ),
					'fourtyfour' => esc_html__( 'Style 44', 'bwd-creative-buttons' ),
					'fourtyfive' => esc_html__( 'Style 45', 'bwd-creative-buttons' ),
					'fourtysix' => esc_html__( 'Style 46', 'bwd-creative-buttons' ),
					'fourtyseven' => esc_html__( 'Style 47', 'bwd-creative-buttons' ),
					'fourtyeight' => esc_html__( 'Style 48', 'bwd-creative-buttons' ),
					'fourtynine' => esc_html__( 'Style 49', 'bwd-creative-buttons' ),
					'fifty' => esc_html__( 'Style 50', 'bwd-creative-buttons' ),
					'fiftyone' => esc_html__( 'Style 51', 'bwd-creative-buttons' ),
					'fiftytwo' => esc_html__( 'Style 52', 'bwd-creative-buttons' ),
					'fiftythree' => esc_html__( 'Style 53', 'bwd-creative-buttons' ),
					'fiftyfour' => esc_html__( 'Style 54', 'bwd-creative-buttons' ),
					'fiftyfive' => esc_html__( 'Style 55', 'bwd-creative-buttons' ),
					'fiftysix' => esc_html__( 'Style 56', 'bwd-creative-buttons' ),
					'fiftyseven' => esc_html__( 'Style 57', 'bwd-creative-buttons' ),
					'fiftyeight' => esc_html__( 'Style 58', 'bwd-creative-buttons' ),
					'fiftynine' => esc_html__( 'Style 59', 'bwd-creative-buttons' ),
					'sixty' => esc_html__( 'Style 60', 'bwd-creative-buttons' ),
					'sixtyone' => esc_html__( 'Style 61', 'bwd-creative-buttons' ),
					'sixtytwo' => esc_html__( 'Style 62', 'bwd-creative-buttons' ),
					'sixtythree' => esc_html__( 'Style 63', 'bwd-creative-buttons' ),
					'sixtyfour' => esc_html__( 'Style 64', 'bwd-creative-buttons' ),
					'sixtyfive' => esc_html__( 'Style 65', 'bwd-creative-buttons' ),
					'sixtysix' => esc_html__( 'Style 66', 'bwd-creative-buttons' ),
					'sixtyseven' => esc_html__( 'Style 67', 'bwd-creative-buttons' ),
					'sixtyeight' => esc_html__( 'Style 68', 'bwd-creative-buttons' ),
					'sixtynine' => esc_html__( 'Style 69', 'bwd-creative-buttons' ),
					'seventy' => esc_html__( 'Style 70', 'bwd-creative-buttons' ),
					'seventyone' => esc_html__( 'Style 71', 'bwd-creative-buttons' ),
					'seventytwo' => esc_html__( 'Style 72', 'bwd-creative-buttons' ),
					'seventythree' => esc_html__( 'Style 73', 'bwd-creative-buttons' ),
					'seventyfour' => esc_html__( 'Style 74', 'bwd-creative-buttons' ),
					'seventyfive' => esc_html__( 'Style 75', 'bwd-creative-buttons' ),
					'seventysix' => esc_html__( 'Style 76', 'bwd-creative-buttons' ),
					'seventyseven' => esc_html__( 'Style 77', 'bwd-creative-buttons' ),
					'seventyeight' => esc_html__( 'Style 78', 'bwd-creative-buttons' ),
					'seventynine' => esc_html__( 'Style 79', 'bwd-creative-buttons' ),
					'eighty' => esc_html__( 'Style 80', 'bwd-creative-buttons' ),
					'eightyone' => esc_html__( 'Style 81', 'bwd-creative-buttons' ),
					'eightytwo' => esc_html__( 'Style 82', 'bwd-creative-buttons' ),
					'eightythree' => esc_html__( 'Style 83', 'bwd-creative-buttons' ),
					'eightyfour' => esc_html__( 'Style 84', 'bwd-creative-buttons' ),
					'eightyfive' => esc_html__( 'Style 85', 'bwd-creative-buttons' ),
					'eightysix' => esc_html__( 'Style 86', 'bwd-creative-buttons' ),
					'eightyseven' => esc_html__( 'Style 87', 'bwd-creative-buttons' ),
					'eightyeight' => esc_html__( 'Style 88', 'bwd-creative-buttons' ),
					'eightynine' => esc_html__( 'Style 89', 'bwd-creative-buttons' ),
					'ninety' => esc_html__( 'Style 90', 'bwd-creative-buttons' ),
					'ninetyone' => esc_html__( 'Style 91', 'bwd-creative-buttons' ),
					'ninetytwo' => esc_html__( 'Style 92', 'bwd-creative-buttons' ),
					'ninetythree' => esc_html__( 'Style 93', 'bwd-creative-buttons' ),
					'ninetyfour' => esc_html__( 'Style 94', 'bwd-creative-buttons' ),
					'ninetyfive' => esc_html__( 'Style 95', 'bwd-creative-buttons' ),
					'ninetysix' => esc_html__( 'Style 96', 'bwd-creative-buttons' ),
					'ninetyseven' => esc_html__( 'Style 97', 'bwd-creative-buttons' ),
					'ninetyeight' => esc_html__( 'Style 98', 'bwd-creative-buttons' ),
					'ninetynine' => esc_html__( 'Style 99', 'bwd-creative-buttons' ),
					'onehundred' => esc_html__( 'Style 100', 'bwd-creative-buttons' ),
					'onehundredone' => esc_html__( 'Style 101', 'bwd-creative-buttons' ),
					'onehundredtwo' => esc_html__( 'Style 102', 'bwd-creative-buttons' ),
					'onehundredthree' => esc_html__( 'Style 103', 'bwd-creative-buttons' ),
					'onehundredfour' => esc_html__( 'Style 104', 'bwd-creative-buttons' ),
					'onehundredfive' => esc_html__( 'Style 105', 'bwd-creative-buttons' ),
					'onehundredsix' => esc_html__( 'Style 106', 'bwd-creative-buttons' ),
					'onehundredseven' => esc_html__( 'Style 107', 'bwd-creative-buttons' ),
					'onehundredeight' => esc_html__( 'Style 108', 'bwd-creative-buttons' ),
					'onehundrednine' => esc_html__( 'Style 109', 'bwd-creative-buttons' ),
					'onehundredten' => esc_html__( 'Style 110', 'bwd-creative-buttons' ),
					'onehundredeleven' => esc_html__( 'Style 111', 'bwd-creative-buttons' ),
				],
			]
		);
		$this->add_control(
			'cbtns_text_buttons', [
				'label' => esc_html__( 'Text', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::TEXT,
				'default' => esc_html__( 'Click Here' , 'bwd-creative-buttons' ),
				'label_block' => true,
			]
		);
		$this->add_control(
			'cbtns_link_buttons',
			[
				'label' => esc_html__( 'Link', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::URL,
				'placeholder' => esc_attr__( 'https://www.your-link.com', 'bwd-creative-buttons' ),
				'default' => [
					'url' => '#',
					'is_external' => true,
					'nofollow' => true,
					'custom_attributes' => '',
				],
			]
		);
		$this->add_control(
			'cbtns_alignment_buttons',
			[
				'label' => esc_html__( 'Alignment', 'bwd-creative-buttons' ),
				'type' => \Elementor\Controls_Manager::CHOOSE,
				'options' => [
					'start' => [
						'title' => esc_html__( 'Left', 'bwd-creative-buttons' ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', 'bwd-creative-buttons' ),
						'icon' => 'eicon-text-align-center',
					],
					'end' => [
						'title' => esc_html__( 'Right', 'bwd-creative-buttons' ),
						'icon' => 'eicon-text-align-right',
					],
				],
				'default' => 'center',
				'toggle' => true,
				'selectors' => [
					'{{WRAPPER}} .cbtns-button-box' => 'text-align: {{VALUE}};',
				],
			]
		);

		$this->add_control(
			'cbtns_buttons_a',
			[
				'type' => Controls_Manager::DIVIDER,
			]
		);

		$this->add_control(
			'cbtns_buttons_icon_switcher',
			[
				'label' => esc_html__( 'Show Icon (If Has)', 'bwd-creative-buttons' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwd-creative-buttons' ),
				'label_off' => esc_html__( 'Hide', 'bwd-creative-buttons' ),
				'return_value' => 'yes',
				'default' => 'no',
			]
		);
		$this->add_control(
			'cbtns_content_icon_button',
			[
				'label' => esc_html__( 'Icon', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::ICONS,
				'default' => [
					'value' => 'fab fa-facebook-f',
					'library' => 'solid',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->add_control(
			'cbtns_buttons_icon_positions',
			[
				'label' => esc_html__( 'Position', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'icon_position_right',
				'options' => [
					'icon_position_right' => esc_html__( 'Right', 'bwd-creative-buttons' ),
					'icon_position_left' => esc_html__( 'Left', 'bwd-creative-buttons' ),
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		// Hover
		$this->start_controls_tabs(
			'cbtns_title_style_tabsxs'
		);

		$this->start_controls_tab(
			'cbtns_title_style_normal_tabxx',
			[
				'label' => esc_html__( 'Normal', 'bwd-creative-buttons' ),
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		
		$this->add_control(
			'cbtns_content_quote_right_color',
			[
				'label' => esc_html__( 'Color', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .cbtns-icon i' => 'color: {{VALUE}}',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'cbtns_button_hoveraaaa_sssssbackground',
				'label' => esc_html__( 'Background Type', 'bwd-creative-buttons' ),
				'types' => [ 'classic', 'gradient', 'video' ],
				'selector' => '{{WRAPPER}} .cbtns-icon',
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->add_control(
			'cbtns_content_quote_right_hover_color',
			[
				'label' => esc_html__( 'Background Color', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .cbtns-icon' => 'background: {{VALUE}}',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->end_controls_tab();

		$this->start_controls_tab(
			'cbtns_title_style_hover_tabaa',
			[
				'label' => esc_html__( 'Hover', 'bwd-creative-buttons' ),
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		
		$this->add_control(
			'cbtns_content_quote_right_colorss',
			[
				'label' => esc_html__( 'Color', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} a:hover .cbtns-icon' => 'color: {{VALUE}}',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'cbtns_button_hoveraaaa_background',
				'label' => esc_html__( 'Background Type', 'bwd-creative-buttons' ),
				'types' => [ 'classic', 'gradient', 'video' ],
				'selector' => '{{WRAPPER}} a:hover .cbtns-icon',
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->add_control(
			'cbtns_content_quote_right_hover_colordd',
			[
				'label' => esc_html__( 'Hover Background', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} a:hover .cbtns-icon' => 'background: {{VALUE}}',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover end

		
		$this->add_responsive_control(
			'cbtns_buttons_the_box_right_icon_size',
			[
				'label' => esc_html__( 'Icon Size', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'devices' => [ 'desktop', 'laptop', 'tablet', 'tablet_extra', 'mobile', 'mobile_extra' ],
				'desktop_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'laptop' => [
					'size' => '',
					'unit' => 'px',
				],
				'tablet_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'tablet_extra' => [
					'size' => '',
					'unit' => 'px',
				],
				'mobile_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'mobile_extra' => [
					'size' => '',
					'unit' => 'px',
				],
				'selectors' => [
					'{{WRAPPER}} .cbtns-icon' => 'font-size: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);


		$this->add_control(
			'cbtns_buttons_sk',
			[
				'type' => Controls_Manager::DIVIDER,
			]
		);

		$this->add_responsive_control(
			'cbtns_buttons_social_border_height',
			[
				'label' => esc_html__( 'Height', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'devices' => [ 'desktop', 'laptop', 'tablet', 'tablet_extra', 'mobile', 'mobile_extra' ],
				'desktop_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'laptop' => [
					'size' => '',
					'unit' => 'px',
				],
				'tablet_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'tablet_extra' => [
					'size' => '',
					'unit' => 'px',
				],
				'mobile_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'mobile_extra' => [
					'size' => '',
					'unit' => 'px',
				],
				'selectors' => [
					'{{WRAPPER}} a .cbtns-icon' => 'block-size: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->add_responsive_control(
			'cbtns_buttons_social_border_width',
			[
				'label' => esc_html__( 'Width', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'devices' => [ 'desktop', 'laptop', 'tablet', 'tablet_extra', 'mobile', 'mobile_extra' ],
				'desktop_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'laptop' => [
					'size' => '',
					'unit' => 'px',
				],
				'tablet_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'tablet_extra' => [
					'size' => '',
					'unit' => 'px',
				],
				'mobile_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'mobile_extra' => [
					'size' => '',
					'unit' => 'px',
				],
				'selectors' => [
					'{{WRAPPER}} a .cbtns-icon' => 'inline-size: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);
		$this->add_responsive_control(
			'cbtns_buttons_social_border_radius',
			[
				'label' => esc_html__( 'Border Radius', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'devices' => [ 'desktop', 'laptop', 'tablet', 'tablet_extra', 'mobile', 'mobile_extra' ],
				'desktop_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'laptop' => [
					'size' => '',
					'unit' => 'px',
				],
				'tablet_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'tablet_extra' => [
					'size' => '',
					'unit' => 'px',
				],
				'mobile_default' => [
					'size' => '',
					'unit' => 'px',
				],
				'mobile_extra' => [
					'size' => '',
					'unit' => 'px',
				],
				'selectors' => [
					'{{WRAPPER}} a .cbtns-icon' => 'border-radius: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'cbtns_buttons_icon_switcher' => 'yes',
				],
			]
		);

		$this->add_control(
			'cbtns_buttons_ska',
			[
				'type' => Controls_Manager::DIVIDER,
			]
		);

		$this->add_control(
			'cbtns_buttons_custom_class_id', [
				'label' => esc_html__( 'Class ID (Custom)', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::TEXT,
				'label_block' => true,
				'description' => sprintf(
					esc_html__( 'Please make sure the Class and ID is unique. This field allows %1$sA-z 0-9%2$s & underscore chars without spaces.', 'bwd-creative-buttons' ),
					'<code>',
					'</code>'
				),
			]
		);
		$this->end_controls_section();

		$this->start_controls_section(
			'cbtns_buttons_style_section',
			[
				'label' => esc_html__( 'Buttons Style', 'bwd-creative-buttons' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'cbtns_buttons_content_typography',
				'selector' => '{{WRAPPER}} .cbtns-title, a:before, a:after, .cbtns_creative_buttons a',
			]
		);
		$this->add_control(
			'cbtns_buttons_text_shadow', [
				'label' => esc_html__( 'Text Shadow', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::TEXT_SHADOW,
				'default' => [
					'color' => 'transparent'
				],
				'selectors' => [
					'{{SELECTOR}} {{WRAPPER}} .cbtns-title' => 'text-shadow: {{HORIZONTAL}}px {{VERTICAL}}px {{BLUR}}px {{COLOR}};',
				],
			]
		);
		// Hover
		$this->start_controls_tabs(
			'cbtns_title_style_tabs'
		);

		$this->start_controls_tab(
			'cbtns_title_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', 'bwd-creative-buttons' ),
			]
		);
		
		$this->add_control(
			'cbtns_title_content_text_normal_color',
			[
				'label' => esc_html__( 'Text Color', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .cbtns_creative_buttons .cbtns-title' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'cbtns_button_normal_background',
				'label' => esc_html__( 'Background Type', 'bwd-creative-buttons' ),
				'types' => [ 'classic', 'gradient', 'video' ],
				'selector' => '{{WRAPPER}} .cbtns_creative_buttons .cbtns-title',
			]
		);
		$this->add_control(
			'cbtns_title_content_normal_color',
			[
				'label' => esc_html__( 'Background Color', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .cbtns_creative_buttons .cbtns-title' => 'background: {{VALUE}}',
					
				],
			]
		);
		$this->end_controls_tab();

		$this->start_controls_tab(
			'cbtns_title_style_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwd-creative-buttons' ),
			]
		);
		
		$this->add_control(
			'cbtns_title_content_text_hover_color',
			[
				'label' => esc_html__( 'Text Color', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .cbtns_creative_buttons .cbtns-title:hover' => 'color: {{VALUE}}',
					
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'cbtns_button_hover_background',
				'label' => esc_html__( 'Background Type', 'bwd-creative-buttons' ),
				'types' => [ 'classic', 'gradient', 'video' ],
				'selector' => '{{WRAPPER}} .cbtns_creative_buttons .cbtns-title::before, .cbtns_creative_buttons .cbtns-title:hover',
			]
		);
		$this->add_control(
			'cbtns_title_content_hover_color',
			[
				'label' => esc_html__( 'Background Color', 'bwd-creative-buttons' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .cbtns_creative_buttons .cbtns-title::before' => 'background: {{VALUE}}',
					'{{WRAPPER}} .cbtns_creative_buttons .cbtns-title::before' => 'border-color: {{VALUE}}', // Style no 56
					'{{WRAPPER}} .cbtns_creative_buttons .cbtns-title::after' => 'border-color: {{VALUE}}', // Style no 56
					'{{WRAPPER}} .cbtns_creative_buttons .cbtns-title:hover' => 'background: {{VALUE}}',
					'{{WRAPPER}} .cbtns_creative_buttons .cbtns-title:hover' => 'background: {{VALUE}}',
					
				],
			]
		);
		$this->add_control(
			'cbtns_buttons_entrance_animation',
			[
				'label' => esc_html__( 'Entrance Animation', 'bwd-creative-buttons' ),
				'type' => \Elementor\Controls_Manager::ANIMATION,
				'prefix_class' => '.cbtns_creative_buttons',
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover end
		
		$this->add_responsive_control(
            'cbtns_buttons_border_radius',
            [
                'label' => esc_html__('Border Radius', 'bwd-creative-buttons'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', '%'],
                'selectors' => [
                    '{{WRAPPER}} .cbtns_creative_buttons .cbtns-title' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ],
            ]
        );
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'cbtns_buttons_box_shadow',
				'label' => esc_html__( 'Box Shadow', 'bwd-creative-buttons' ),
				'selector' => '{{WRAPPER}} .cbtns_creative_buttons .cbtns-title',
			]
		);
		$this->add_responsive_control(
            'cbtns_buttons_padding',
            [
                'label' => esc_html__('Padding', 'bwd-creative-buttons'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', '%'],
                'selectors' => [
                    '{{WRAPPER}} .cbtns_creative_buttons .cbtns-title, .cbtns_creative_buttons .cbtns-title:after, .cbtns-btn-eleven .cbtns-title' => 'padding-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; padding-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
		$this->end_controls_section();

	}
	protected function render() {
		$settings = $this->get_settings_for_display();
		$cbtns_styles = $settings['cbtns_style_selection'];
		// Social Link
		if ( ! empty( $settings['cbtns_link_buttons']['url'] ) ) {
			$this->add_link_attributes( 'cbtns_link_buttons', $settings['cbtns_link_buttons'] );
		}
		?>
			<div class="cbtns-button-box">
			<?php
			// Single buttons
			if( $cbtns_styles ){ ?>
				<div class="cbtns-btn-<?php echo $cbtns_styles ?> cbtns_creative_buttons <?php echo esc_attr($settings['cbtns_buttons_custom_class_id']); ?>">
					<a href="<?php echo esc_url($settings['cbtns_link_buttons']['url']); ?>">
					<div class="cbtns-title"><?php echo esc_html__($settings['cbtns_text_buttons']); ?></div>
					   <?php if($cbtns_styles == 'two'){?>
							<span style="top: 59.7969px; left: 2.46875px;"></span>
					   <?php }
					   if($cbtns_styles == 'fourty'){?>
					    	<span></span>
						<?php }
						if($cbtns_styles == 'fiftythree'){?>
							<span></span>
							<span></span>
							<span></span>
							<span></span>
							<span></span>
						<?php }
						if($cbtns_styles == 'eightyone'){?>
							<div class="liquid"></div>
						<?php }
						if($cbtns_styles == 'eightythree'){?>
							<span></span>
							<span></span>
						<?php }
						if($cbtns_styles == 'eightysix'){?>
							<span></span>
						<?php }?>
					</a>
				</div>
			    <?php
			}?>
		</div> <!-- Buttons Alignment -->
		<?php
	}
}
